C======================================================================+
      SUBROUTINE TRUST5 (N,X,BODY2,NUMAT3,IOPTN,HESSE,HVAL,WORK,DRG)    DJG0496
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'SIZES.i'
      INCLUDE 'KEYS.i'                                                  DJG0496
      PARAMETER (MSIZE=NUMATM*(NUMATM-1)/2, MXPAR2=MAXPAR**2)
      DIMENSION X(*),BODY2(NUMAT3,*),HESSE(*),HVAL(*),WORK(*),DRG(3,*)
C ----------------------------------------------------------------------
C     TRUST METHODS. APPROXIMATE HESSIAN FROM 2-BODY PARTITIONNING.
C     D. LIOTARD, APRIL 1992 (AMPAC) ... JANUARY 1996 (AMSOL).
C     POLYMER, CI AND SOLVATION NOT TAKEN INTO ACCOUNT (NOT A PROBLEM).
C  INPUT
C     N:                 NUMBER OF OPTIMIZED PARAMETERS.
C     X(N):              OPTIMIZED PARAMETERS.
C     NUMAT:             NUMBER OF NON-DUMMY ATOMS.
C     NUMAT3:            NUMAT*3
C     COORD(3,NUMAT):    CARTESIAN COORDINATES.
C     BJACOB(N,NUMAT3):  JACOBIAN MATRIX (SEE 'DERIV')
C     RG(3,MSIZE):       2-BODY CARTESIAN DERIVATIVES (SEE 'DCART').
C     BODY2(NUMAT3,NUMAT3): WORK ARRAY (NOT LOCATED IN /SCRCHR/)
C     HVAL(NUMAT3)        : WORK ARRAY (NOT LOCATED IN /SCRCHR/)
C     DRG(3,MSIZE)        : WORK ARRAY (NOT LOCATED IN /SCRCHR/)
C     WORK(NUMAT3**2)     : WORK ARRAY
C     IOPTN  :            OUTPUT OPTION, SEE BELOW.                     DJG0496
C  OUTPUT
C     COORD(3,NUMAT):    CENTERED ON GEOMETRIC CENTER.
C     BJACOB(N,NUMAT3):  NOT MODIFIED.
C     RG(3,MSIZE):       DESTROYED.
C   * IOPTN= 0                                                          DJG0496
C     HESSE(*): 2-BODY HESSIAN, NOT NECESSARILY DEFINITE POSITIVE.
C   * IOPTI= 1                                                          DJG0496
C     HESSE(*): 2-BODY HESSIAN,     NECESSARILY DEFINITE POSITIVE.
C --------------------------------------------------------------------
      COMMON /HBODY2/ RG(3,MSIZE),BJACOB(MAXPAR**2),COORD(3,NUMATM)
     1       /SCRCHR/ WORK2(MAXPAR**2),R(MSIZE),UN(3,MSIZE)
     2               ,ENER(MSIZE,2),DUM(5*MAXPAR**2+1-MSIZE*6)          DL0397
      COMMON /CYCLCM/ PCMIN,NGEOM,NSOLPR,NSCFS,JPCNT
     1       /WMATRX/ WJ(N2ELEC),WK(N2ELEC*2),NWDUM(NUMATM+1)
     2       /ENUCLR/ ENUCLR
     3       /ELECT / ELECT
     4       /HMATRX/ H(MPACK)
     5       /GEOKST/ NATOMS,LABELS(NUMATM),NABC(3,NUMATM)
     6       /MLKSTI/ NUMAT,NAT(NUMATM),NFIRST(NUMATM),NMIDLE(NUMATM),
     7                NLAST(NUMATM),NORBS,NELECS,NALPHA,NBETA,
     8                NCLOSE,NOPEN,NDUMY
     9       /PRECI / SCFCRT,SCFTOL,EG(3),ESTIM(3),PMAX(3),KTYP(MAXPAR)
      DIMENSION HESTIM(4),W(1)
      EQUIVALENCE (W,WJ)
C     EXPANSION' FINITE DIFFERENCE RATIO AND RELEVANT COEFFICIENT.
      EPS=MAX(2D-5,MIN(EG(1)*2,2D-3))
      FACTOR=1D0+EPS
      FACT2=1D0/EPS
C     SET UP THE JACOBIAN MATRIX
      CALL JCARIN (COORD,X,.FALSE.,BJACOB,NCOL)
C     TRANSLATE CARTESIAN COORDINATES OF THE CURRENT POINT.
      XG=0D0
      YG=0D0
      ZG=0D0
      DO 10 I=1,NUMAT
      XG=XG+COORD(1,I)
      YG=YG+COORD(2,I)
   10 ZG=ZG+COORD(3,I)
      XG=-XG/DBLE(NUMAT)
      YG=-YG/DBLE(NUMAT)
      ZG=-ZG/DBLE(NUMAT)
      DO 20 I=1,NUMAT
      COORD(1,I)=COORD(1,I)+XG
      COORD(2,I)=COORD(2,I)+YG
   20 COORD(3,I)=COORD(3,I)+ZG
C     2-BODY GRADIENTS DRG(3,*) AT THE CURRENT POINT
C     (KCAL/MOLE/ANGSTROMS)
      CALL DCART (COORD,WORK)                                            DL0496
      LENRG=NUMAT*(NUMAT-1)/2
      CALL SCOPY (LENRG*3,RG,1,DRG,1)
C     2-BODY GRADIENTS RG(3,*) AT THE "EXPANDED" CURRENT POINT
      DO 30 I=1,NUMAT3
   30 COORD(I,1)=COORD(I,1)*FACTOR
      NGEOM=NGEOM+1
      CALL HCORE (COORD,H,W,WJ,WK,ENUCLR)
      CALL ITER (H,W,WJ,WK,ELECT,.FALSE.,.FALSE.)
      CALL DCART (COORD,WORK)                                            DL0496
      DO 40 I=1,NUMAT3
   40 COORD(I,1)=COORD(I,1)/FACTOR
C
C     NOW TO BUILD THE 2-BODY HESSIAN IN CARTESIAN COORDINATES:
C     MODEL= SUM-OVER-i-&-j-OF Fij(Rij) TWICE DERIVATED.
C
C     INTERATOMIC UNIT VECTORS UN(3,IJ) AND INVERSE DISTANCES R(IJ)
      IJ=0
      DO 100 I=2,NUMAT
      DO 100 J=1,I-1
      IJ=IJ+1
      UN(1,IJ)=COORD(1,I)-COORD(1,J)
      UN(2,IJ)=COORD(2,I)-COORD(2,J)
      UN(3,IJ)=COORD(3,I)-COORD(3,J)
      R(IJ)=1D0/SQRT(UN(1,IJ)**2+UN(2,IJ)**2+UN(3,IJ)**2)
      UN(1,IJ)=UN(1,IJ)*R(IJ)
      UN(2,IJ)=UN(2,IJ)*R(IJ)
  100 UN(3,IJ)=UN(3,IJ)*R(IJ)
C     DRG(k,ij) = dFij/dXk     Xk CARTESIAN COORDINATE OF ATOM j.
C     RG: VARIATIONS OF DRG'S
C     ENER(COLUMN 1): 1/R*dE/dR   ENER(COLUMN 2): d2E/dR2 - 1/R*dE/dR
C     FROM ISOTROPIC MODEL: MEAN VALUES WEIGHTED WITH DIRECTOR COSINE.
      DO 110 I=1,IJ
      RG(1,I)=FACT2*(RG(1,I)-DRG(1,I))*R(I)
      RG(2,I)=FACT2*(RG(2,I)-DRG(2,I))*R(I)
      RG(3,I)=FACT2*(RG(3,I)-DRG(3,I))*R(I)
      ENER(I,1)=R(I)*(DRG(1,I)*UN(1,I)+DRG(2,I)*UN(2,I)
     .+DRG(3,I)*UN(3,I))
  110 ENER(I,2)=RG(1,I)*UN(1,I)+RG(2,I)*UN(2,I)+RG(3,I)*UN(3,I)
     .-ENER(I,1)
C
C     2-BODY CARTESIAN HESSIAN BODY2(NUMAT3,NUMAT3)
C
      CALL SCOPY (NUMAT3**2,0D0,0,BODY2,1)
      IJ=1
      DO 120 I=4,NUMAT3-2,3
      DO 120 J=1,I-3,3
C     ISOTROPIC HESSIAN (EXACT FOR RHF UHF DIATOMIC MOLECULES).
      H11=ENER(IJ,1)+ENER(IJ,2)*UN(1,IJ)**2
      H22=ENER(IJ,1)+ENER(IJ,2)*UN(2,IJ)**2
      H33=ENER(IJ,1)+ENER(IJ,2)*UN(3,IJ)**2
      H21=ENER(IJ,2)*UN(2,IJ)*UN(1,IJ)
      H31=ENER(IJ,2)*UN(3,IJ)*UN(1,IJ)
      H32=ENER(IJ,2)*UN(3,IJ)*UN(2,IJ)
C     NON-ISOTROPIC 2-BODY CORRECTION BY RANK 1 FORMULA (POWELL).
      V1=RG(1,IJ)-H11*UN(1,IJ)-H21*UN(2,IJ)-H31*UN(3,IJ)
      V2=RG(2,IJ)-H21*UN(1,IJ)-H22*UN(2,IJ)-H32*UN(3,IJ)
      V3=RG(3,IJ)-H31*UN(1,IJ)-H32*UN(2,IJ)-H33*UN(3,IJ)
      H11=H11+UN(1,IJ)*2D0*V1
      H22=H22+UN(2,IJ)*2D0*V2
      H33=H33+UN(3,IJ)*2D0*V3
      H21=H21+UN(1,IJ)*V2+UN(2,IJ)*V1
      H31=H31+UN(1,IJ)*V3+UN(3,IJ)*V1
      H32=H32+UN(2,IJ)*V3+UN(3,IJ)*V2
      BODY2(I  ,I  )=BODY2(I  ,I  )+H11
      BODY2(I+1,I+1)=BODY2(I+1,I+1)+H22
      BODY2(I+2,I+2)=BODY2(I+2,I+2)+H33
      BODY2(J  ,J  )=BODY2(J  ,J  )+H11
      BODY2(J+1,J+1)=BODY2(J+1,J+1)+H22
      BODY2(J+2,J+2)=BODY2(J+2,J+2)+H33
      BODY2(I+1,I  )=BODY2(I+1,I  )+H21
      BODY2(I+2,I  )=BODY2(I+2,I  )+H31
      BODY2(I+2,I+1)=BODY2(I+2,I+1)+H32
      BODY2(J+1,J  )=BODY2(J+1,J  )+H21
      BODY2(J+2,J  )=BODY2(J+2,J  )+H31
      BODY2(J+2,J+1)=BODY2(J+2,J+1)+H32
      BODY2(I  ,J  )=BODY2(I  ,J  )-H11
      BODY2(I+1,J  )=BODY2(I+1,J  )-H21
      BODY2(I+2,J  )=BODY2(I+2,J  )-H31
      BODY2(I  ,J+1)=BODY2(I  ,J+1)-H21
      BODY2(I+1,J+1)=BODY2(I+1,J+1)-H22
      BODY2(I+2,J+1)=BODY2(I+2,J+1)-H32
      BODY2(I  ,J+2)=BODY2(I  ,J+2)-H31
      BODY2(I+1,J+2)=BODY2(I+1,J+2)-H32
      BODY2(I+2,J+2)=BODY2(I+2,J+2)-H33
  120 IJ=IJ+1
      DO 130 I=2,NUMAT3
      DO 130 J=1,I-1
  130 BODY2(J,I)=BODY2(I,J)
C     TRANSLATION/ROTATION NOT PROJECTED OUT FROM CARTESIAN HESSIAN:
C     TRUST METHODS NOT AFFECTED SIGNIFICANTLY.
      IF (NABC(1,1).NE.99.OR.N.NE.NUMAT3) THEN
C        SET HESSIAN IN PARAMETER SPACE, VIA JACOBIAN BJACOB.
         CALL MXM (BJACOB,N,BODY2,NUMAT3,WORK,NUMAT3)
         CALL MXMT (WORK,N,BJACOB,NUMAT3,BODY2,N)
      ENDIF
C
C     RETURN THE HESSIAN ACCORDING TO THE OPTION "IOPTN".               DJG0496
C
C     LOWER BOUNDS FOR DEF-POS HESSIAN EIGENVALUES:
C                  BOND   ANGLE  DIHE  CART
      DATA HESTIM /300D0, 150D0, 75D0, 200D0/
      IF (IOPTN.GE.1) THEN                                              DJG0496
C        DEF-POS HESSIAN REQUIRED.
C        EIGENVALUES AND VECTORS:
         CALL DIAGIV (BODY2,N,N,HVAL,EPS1)                              DL0397
         IF (NABC(1,1).EQ.99) THEN
C           CARTESIAN COORDS: HESTIM(4)
            DO 140 I=1,N
  140       HVAL(I)=MAX(HVAL(I),HESTIM(4))
         ELSE
C           INTERNAL COORDS: WEIGHTED HESTIM(1,2,3)
            DO 160 I=1,N
            VALOW=0D0
            DO 150 J=1,N
  150       VALOW=HESTIM(KTYP(J))*BODY2((I-1)*N+J,1)**2+VALOW
  160       HVAL(I)=MAX(HVAL(I),VALOW)
         ENDIF
         DO 170 J=1,N
         DO 170 I=(J-1)*N+1,J*N
  170    WORK(I)=BODY2(I,1)*HVAL(J)
         CALL MXMT (WORK,N,BODY2,N,WORK2,N)
         CALL CANO (HESSE,N,WORK2,N)
      ELSE
         CALL CANO (HESSE,N,BODY2,N)
      ENDIF
C     FINAL HESSIAN HAS BEEN STORED (CANONICAL) IN HESSE.
      END
